/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: June 10th 2005                              */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef _DSP_H_
#define _DSP_H_
#include "fftw3.h"

#define PI 3.1415926535897932384626433832795

void fft(double *in,double *outr,double *outi,int N);
void ifft(double *inr,double *ini,double *outr,int N);
void fftblock(double *x,double *window,double *fftr,double *ffti,int blocklength);
double *fftspl(double *xr,double *xi,int Nfreq);

void mdct4(double *in,double *out,int N);
void imdct4(double *in,double *out,int K);

void mdctblock(double *x,double *window,double *result,int blocklength);
void imdctblock(double *buffer,double *window,double *result,int blocklength);
double *mdctspl(double *x,int Nfreq);
static double windowgain;

int verifywindow(double *window,int N);
void sinewindow(double *window,int N);
void kbdwindow(double *window,int N,double alpha);
double BesselI0(double x);
void vorbiswindow(double *window,int N);
void rectangularwindow(double *window,int N);
void hanningwindow(double *window,int N);
double computewindowgain(double *window,int N);

#endif