/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: June 15th 2005                              */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef _ENCODE_H_
#define _ENCODE_H_

#include <stdio.h>
#include "types.h"

#define SINEW 0x0
#define KBDW 0x1
#define VORBISW 0x2
#define RECTANGULARW 0xf

#define FDOUBLE 0x0
#define F16BITS 0x1
#define F8BITS 0x2
#define PSYCHOACOUSTIC 0x3

#define SCALEFACTORBITS 6
#define SFLOWER -32
#define SFUPPER 31
#define COMPUTESF(scalefactor) pow(2.0,(double)(scalefactor)/4.0)
#define QUANTIZERRANGE(Nbits) (rangeofquant[Nbits])
/*#define QUANTIZERRANGE(Nbits) ((0x1<<(Nbits-1))-1)*/




struct hdrlegg
{
	unsigned int N; /* 32-bit unsigned int */
	unsigned int sr; /* 32-bit unsigned int */
	BYTE channels;
	BYTE window;
	UWORD mdctsize;
};

struct hdrpckleggsize
{
	UWORD lengthofpacket; /* Length of packet, not including this header */
};
struct hdrpcklegg
{
	struct bitalloc
	{
		BYTE alloc0:4; /* Quantizer size for each sub-band */
		BYTE alloc1:4; 
		BYTE alloc2:4; 
		BYTE alloc3:4; 
		BYTE alloc4:4; 
		BYTE alloc5:4; 
		BYTE alloc6:4; 
		BYTE alloc7:4; 
		BYTE alloc8:4; 
		BYTE alloc9:4; 
		BYTE alloc10:4; 
		BYTE alloc11:4; 
		BYTE alloc12:4; 
		BYTE alloc13:4; 
		BYTE alloc14:4; 
		BYTE alloc15:4; 
		BYTE alloc16:4; 
		BYTE alloc17:4; 
		BYTE alloc18:4; 
		BYTE alloc19:4; 
		BYTE alloc20:4; 
		BYTE alloc21:4; 
		BYTE alloc22:4; 
		BYTE alloc23:4; 
		BYTE alloc24:4; 
		BYTE extra1:4;
	};
		BYTE extra2;			/* Not used, yet */
};


UWORD quantizesignal(double *mdct,double *fftr,double *ffti,double *mask,int Nfreq,BYTE *result);
int quantizeband(BYTE *result,double *mdct,int lower,int upper,int bits,WORD scalefactor,int currentbit);
DWORD quantize(double number,WORD scalefactor,int Nbits);
double dequantize(DWORD quantized,WORD scalefactor,int Nbits);
double midrisevalue(DWORD data,int Nbits);
DWORD midrisequantize(double number,int Nbits);
double midtreadvalue(DWORD data,int Nbits);
DWORD midtreadquantize(double number,int Nbits);
int writebits(BYTE *buffer,DWORD data,int numberofbits,int startbit);
int readbits(BYTE *buffer,DWORD *data,int numberofbits,int startbit);

void dequantizesignal(BYTE *bitallocations,BYTE *buffer,int lengthofpacket,double *mdctleft);
int dequantizeband(BYTE *buffer,double *normalizedbands,int lower,int upper,int bits,WORD scalefactor,int startbit);

#endif
