/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: May 17th 2005                               */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef _PSYCHOACOUSTICS_H_
#define _PSYCHOACOUSTICS_H_

#define UNMASKED 0
#define COMPUTED 1
#define MASKED 70


void initpsychoacoustic(int Nfreq,int samplingrate);
void freepsychoacoustic(void);

void mpegpm2(double spl,int todo,int Nfreq,int start,int end,double delta,double alpha);
void computemask(double *fftr,double *ffti,int Nfreq,int maxfreq,double *result);
int nexttocomputemask(double *spl,short int *barkflagged,int Nbark);
double signaltomaskratio(double *spl,double *mask,int b);
int getbandsize(int b);
void getbandlimits(int b,int *lower,int *upper);
#endif
