/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: May 17th 2005                               */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef _TYPES_H_
#define _TYPES_H_

/* Types should be adjusted depending upon the computer architecture.
Data in a WAV file is stored in little endian format.
These types work for Win32 and Linux x86 IA32:
	typedef unsigned char BYTE;
	typedef short int WORD;
	typedef unsigned int DWORD;
 */
typedef unsigned char BYTE;
typedef short int WORD;
typedef unsigned int DWORD;
typedef unsigned short int UWORD;
typedef unsigned long int QWORD;

struct float8
{
	BYTE sign:1;
	BYTE exp:3;
	BYTE mantisa:4;
};
typedef struct float8 FLOAT8;
#define MAXF8 15.0f
float float8tofloat(FLOAT8 *in);
void floattofloat8(float in,FLOAT8 *out);

struct float16
{
	UWORD sign:1;
	UWORD exp:5;
	UWORD mantisa:10;
};
typedef struct float16 FLOAT16;
#define MAXF16 65535.0f
float float16tofloat(FLOAT16 *in);
void floattofloat16(float in,FLOAT16 *out);

#endif