/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: June 8th 2005                               */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef _WAV_H_
#define _WAV_H_

#include "types.h"


#define WAVE_FORMAT_PCM		0x0001
#define FORMAT_MULAW		0x0101
#define IBM_FORMAT_ALAW		0x0102
#define IBM_FORMAT_ADPCM	0x0103

struct wavfile
{
	FILE *fwav;
	int samplerate;
	int bitspersample;
	int channels;
	unsigned int totalsamples;
	unsigned int samplesread;
};
typedef struct wavfile WAVFILE;


struct riff_hdr 
{    
	BYTE id[4];			/* identifier string = "RIFF" */
	DWORD len;			/* remaining length after this header */
};

struct wav_hdr
{
	BYTE wave_id[4];	/* Identificador de archivo = "WAVE" */
	BYTE id[4];			/* identificador, "fmt " or "data" */
	DWORD len;			/* Tamao de los datos despues de esta cabecera */
};


struct wavfmtck
{
	WORD wFormatTag;			/* Format */
	WORD wChannels;				/* Number of channels */
	DWORD dwSamplesPerSec;		/* Sampling frequency */
	DWORD dwAvgBytesPerSec;		/* Used for buffer estimation */
	WORD wBlockAlign;			/* Size of data block */
	WORD wBitsPerSample;		/* Bits per sample */
};

struct datachunk_hdr
{
	BYTE chunkID[4];		/* Identifier, "data" for sound chunk */
	DWORD chunkSize;		/* Size of chunk */
};

struct sample
{
	WORD wLeft;
	WORD wRight;
}; /* Assumes 44100,16 bits, stereo */

int readinfo(WAVFILE *wav);
int readsample(WAVFILE *wav,struct sample *ssample);
void writeinfo(WAVFILE *wav);
int writesample(WAVFILE *wav,double left,double right);
int writewav(WAVFILE *wav,double *left,double *right,double maxl,double maxr);
int readwav(WAVFILE *wav,double **left,double **right);

#endif